
Ruby - Bug #7467

lib/mkmf.rb merge_lib fails on larger sets of libraries

11/29/2012 05:42 PM - mpapis (Michal Papis)

Status: Closed   

Priority: Normal   

Assignee: nobu (Nobuyoshi Nakada)   

Target version: 2.0.0   

ruby -v: ruby 1.9.3p286 (2012-10-12 revision

37165) [x86_64-darwin12.2.0]

Backport:  

Description

running:

merge_libs(["-lncurses", "-ltinfo", "-lssl", "-lcrypto", "-lz", "-lreadline", "-ltermcap", "-lyaml"],["-lcrypto", "-lssl", "-lcrypto", "-lz"],[])

fails with an exception

I have tried a bit and it works fine with a lot simplified version of this code:

def merge_libs(*libs)

libs.flatten.uniq

end

Also can this be backported to Ruby 1.9.3?

Associated revisions

Revision 13b11810e289bc7b946e9c6eac7d1348107f0eda - 02/07/2013 06:33 AM - nobu (Nobuyoshi Nakada)

mkmf.rb: fix merge_libs

lib/mkmf.rb (MakeMakefile#merge_libs): insert following reversal

ordered elements just after the duplicated element, not overwriting

successive elements.  [ruby-core:50314] [Bug #7467]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@39128 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

Revision 13b11810 - 02/07/2013 06:33 AM - nobu (Nobuyoshi Nakada)

mkmf.rb: fix merge_libs

lib/mkmf.rb (MakeMakefile#merge_libs): insert following reversal

ordered elements just after the duplicated element, not overwriting

successive elements.  [ruby-core:50314] [Bug #7467]

git-svn-id: svn+ssh://ci.ruby-lang.org/ruby/trunk@39128 b2dd03c8-39d4-4d8f-98ff-823fe69b080e

History

#1 - 11/29/2012 07:07 PM - mpapis (Michal Papis)

here is a link to a working patch: https://github.com/tokaido/tokaido-build/blob/master/patches/darwin/1.9.3-p327/fix_merge_libs.patch

#2 - 12/21/2012 10:57 PM - usa (Usaku NAKAMURA)

- Category set to lib

- Status changed from Open to Assigned

- Assignee set to nobu (Nobuyoshi Nakada)

- Target version set to 2.0.0

#3 - 02/07/2013 03:33 PM - nobu (Nobuyoshi Nakada)

- Status changed from Assigned to Closed

- % Done changed from 0 to 100
https://github.com/tokaido/tokaido-build/blob/master/patches/darwin/1.9.3-p327/fix_merge_libs.patch


This issue was solved with changeset r39128.

Michal, thank you for reporting this issue.

Your contribution to Ruby is greatly appreciated.

May Ruby be with you.

mkmf.rb: fix merge_libs

lib/mkmf.rb (MakeMakefile#merge_libs): insert following reversal

ordered elements just after the duplicated element, not overwriting

successive elements.  [ruby-core:50314] [Bug #7467]

#4 - 02/09/2013 10:43 PM - mpapis (Michal Papis)

just curious what the new code does more over the simple libs.flatten.uniq?
